package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;

public class _jet_order_reporttxt implements JET2Template {
    private static final String _jetns_c = "org.eclipse.jet.controlTags"; //$NON-NLS-1$

    public _jet_order_reporttxt() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_c_setVariable_5_1 = new TagInfo("c:setVariable", //$NON-NLS-1$
            5, 1,
            new String[] {
                "var", //$NON-NLS-1$
                "select", //$NON-NLS-1$
            },
            new String[] {
                "lastCustomerName", //$NON-NLS-1$
                "  ''  ", //$NON-NLS-1$
            } );
    private static final TagInfo _td_c_iterate_10_1 = new TagInfo("c:iterate", //$NON-NLS-1$
            10, 1,
            new String[] {
                "select", //$NON-NLS-1$
            },
            new String[] {
                "sort($os/orders, 'customer/@name')", //$NON-NLS-1$
            } );
    private static final TagInfo _td_c_if_12_3 = new TagInfo("c:if", //$NON-NLS-1$
            12, 3,
            new String[] {
                "test", //$NON-NLS-1$
            },
            new String[] {
                "not($lastCustomerName = customer/@name)", //$NON-NLS-1$
            } );
    private static final TagInfo _td_c_setVariable_14_5 = new TagInfo("c:setVariable", //$NON-NLS-1$
            14, 5,
            new String[] {
                "var", //$NON-NLS-1$
                "select", //$NON-NLS-1$
            },
            new String[] {
                "lastCustomerName", //$NON-NLS-1$
                "customer/@name", //$NON-NLS-1$
            } );
    private static final TagInfo _td_c_iterate_17_3 = new TagInfo("c:iterate", //$NON-NLS-1$
            17, 3,
            new String[] {
                "select", //$NON-NLS-1$
            },
            new String[] {
                "articles", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        // 
        //We will do control-break reporting on customer name.
        //Initialize 'lastCustomerName' to the empty string to start
        RuntimeTagElement _jettag_c_setVariable_5_1 = context.getTagFactory().createRuntimeTag(_jetns_c, "setVariable", "c:setVariable", _td_c_setVariable_5_1); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_c_setVariable_5_1.setRuntimeParent(null);
        _jettag_c_setVariable_5_1.setTagInfo(_td_c_setVariable_5_1);
        _jettag_c_setVariable_5_1.doStart(context, out);
        _jettag_c_setVariable_5_1.doEnd();
        //
        //Traverse all orders under $os (the OrderSytem object).
        //Sort orders by customer name (customer/@name).
        RuntimeTagElement _jettag_c_iterate_10_1 = context.getTagFactory().createRuntimeTag(_jetns_c, "iterate", "c:iterate", _td_c_iterate_10_1); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_c_iterate_10_1.setRuntimeParent(null);
        _jettag_c_iterate_10_1.setTagInfo(_td_c_iterate_10_1);
        _jettag_c_iterate_10_1.doStart(context, out);
        while (_jettag_c_iterate_10_1.okToProcessBody()) {
            // check whether this is a new customer - put out a heading if so 
            RuntimeTagElement _jettag_c_if_12_3 = context.getTagFactory().createRuntimeTag(_jetns_c, "if", "c:if", _td_c_if_12_3); //$NON-NLS-1$ //$NON-NLS-2$
            _jettag_c_if_12_3.setRuntimeParent(_jettag_c_iterate_10_1);
            _jettag_c_if_12_3.setTagInfo(_td_c_if_12_3);
            _jettag_c_if_12_3.doStart(context, out);
            while (_jettag_c_if_12_3.okToProcessBody()) {
                out.write("    Orders for customer: ");  //$NON-NLS-1$        
                out.write(context.embeddedExpressionAsString("${customer/@name}", 13, 26)); //$NON-NLS-1$ //$NON-NLS-2$
                out.write(NL);         
                RuntimeTagElement _jettag_c_setVariable_14_5 = context.getTagFactory().createRuntimeTag(_jetns_c, "setVariable", "c:setVariable", _td_c_setVariable_14_5); //$NON-NLS-1$ //$NON-NLS-2$
                _jettag_c_setVariable_14_5.setRuntimeParent(_jettag_c_if_12_3);
                _jettag_c_setVariable_14_5.setTagInfo(_td_c_setVariable_14_5);
                _jettag_c_setVariable_14_5.doStart(context, out);
                _jettag_c_setVariable_14_5.doEnd();
                _jettag_c_if_12_3.handleBodyContent(out);
            }
            _jettag_c_if_12_3.doEnd();
            out.write("      Order ");  //$NON-NLS-1$        
            out.write(context.embeddedExpressionAsString("${@id}", 16, 13)); //$NON-NLS-1$ //$NON-NLS-2$
            out.write(NL);         
            RuntimeTagElement _jettag_c_iterate_17_3 = context.getTagFactory().createRuntimeTag(_jetns_c, "iterate", "c:iterate", _td_c_iterate_17_3); //$NON-NLS-1$ //$NON-NLS-2$
            _jettag_c_iterate_17_3.setRuntimeParent(_jettag_c_iterate_10_1);
            _jettag_c_iterate_17_3.setTagInfo(_td_c_iterate_17_3);
            _jettag_c_iterate_17_3.doStart(context, out);
            while (_jettag_c_iterate_17_3.okToProcessBody()) {
                out.write("        Article: ");  //$NON-NLS-1$        
                out.write(context.embeddedExpressionAsString("${@description}", 18, 18)); //$NON-NLS-1$ //$NON-NLS-2$
                out.write(NL);         
                _jettag_c_iterate_17_3.handleBodyContent(out);
            }
            _jettag_c_iterate_17_3.doEnd();
            _jettag_c_iterate_10_1.handleBodyContent(out);
        }
        _jettag_c_iterate_10_1.doEnd();
    }
}
